#include <assert.h>
#include <stdio.h>

#include "../list_int.h"

int main() {
    
    struct list_int * l = list_int_new();
    assert(l);
    assert(list_int_begin(l) == list_int_end(l));
    assert(list_int_empty(l));

    struct list_int * i;

    for (int j = 1; j < 10; ++j) {
	assert((i = list_int_append(l, j)));
	assert(list_int_get(i) == j);
    }

    assert(!list_int_empty(l));

    list_int_clear(l);

    assert(list_int_empty(l));

    assert(list_int_append(l, 4));
    assert(list_int_append(l, 5));
    
    i = list_int_begin(l);
    assert(i != list_int_end(l));
    assert(list_int_get(i) == 4);
    i = list_int_next(i);
    assert(i != list_int_end(l));
    assert(list_int_get(i) == 5);
    i = list_int_next(i);
    assert(i == list_int_end(l));
    
    list_int_erase(list_int_begin(l));

    for (int j = 1; j < 100; ++j)
	assert(list_int_append(l, j));

    i = list_int_begin(l);
    assert(i != list_int_end(l));
    assert(list_int_get(i) == 5);

    for (int j = 1; j < 100; ++j) {
	i = list_int_next(i);
	assert(i != list_int_end(l));
	assert(list_int_get(i) == j);
    }

    list_int_clear(l);
    assert(list_int_begin(l) == list_int_end(l));
    assert(list_int_empty(l));

    list_int_append(l, -1);
    i = list_int_begin(l);
    for (int j = 1; j < 100; ++j) {
	i = list_int_insert(i, j);
	assert(i);
	assert(list_int_get(i) == j);
    }
    
    i = list_int_begin(l);
    for (int j = 99; j > 0; --j) {
	assert(list_int_get(i) == j);
	i = list_int_next(i);
	assert(i);
	assert(i != list_int_end(l));
    }
    assert(list_int_get(i) == -1);

    list_int_clear(l);
    assert(list_int_begin(l) == list_int_end(l));

    i = list_int_begin(l);
    assert((i = list_int_insert(i, 1)));
    assert((i = list_int_insert(i, 2)));
    assert((i = list_int_insert(i, 3)));

    i = list_int_begin(l);
    assert(list_int_get(i) == 3);
    i = list_int_next(i);
    assert(list_int_get(i) == 2);
    i = list_int_next(i);
    assert(list_int_get(i) == 1);

    list_int_clear(l);
    i = list_int_begin(l);
    for (int j = 1; j < 100; ++j) {
	i = list_int_insert(i, j);
	assert(i);
	assert(list_int_get(i) == j);
    }
    
    i = list_int_begin(l);
    for (int j = 99; j > 0; --j) {
	assert(list_int_get(i) == j);
	i = list_int_next(i);
    }
    list_int_clear(l);

    for (int j = -1; j >= -100; --j)
	list_int_append(l, j);

    i = list_int_begin(l);
    for (int j = -1; i != list_int_end(l); i = list_int_next(i)) {
	assert(list_int_get(i) == j);
	--j;
    }

    i = list_int_end(l);
    for (int j = -100; j <= -1; ++j) {
	i = list_int_prev(i);
	assert(list_int_get(i) == j);
    }

    list_int_delete(l);
}
